Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 296713 - Fuzzy wording in "updates directory" section
Summary: Fuzzy wording in "updates directory" section
Status: RESOLVED INVALID
Alias: None
Product: Gentoo Hosted Projects
Classification: Unclassified
Component: PMS/EAPI (show other bugs)
Hardware: All Linux
: High normal (vote)
Assignee: PMS/EAPI
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2009-12-13 11:51 UTC by Ulrich Müller
Modified: 2019-08-23 16:17 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Ulrich Müller gentoo-dev 2009-12-13 11:51:30 UTC
PMS should document that updates are applied in chronological order of the files, and within each file, in the order that they occur in the file.

For example, it plays a role in the case that a slotmove is later followed by a move for the same package. 

Also: "Any name that has appeared as the origin of a move must not be reused in the future." What does this mean? Is that name burned forever, even if it's later removed from updates?
Comment 1 Ciaran McCreesh 2009-12-13 14:14:59 UTC
I believe current policy is that you're not allowed to remove things from updates, and that you're not allowed to move things that have already been moved, hence the wording. Did that change?
Comment 2 Ulrich Müller gentoo-dev 2009-12-13 15:52:29 UTC
(In reply to comment #1)
> I believe current policy is that you're not allowed to remove things from
> updates, and that you're not allowed to move things that have already been
> moved, hence the wording. Did that change?

Where is this policy documented?

So if a dev makes a mistake and writes "move bar foo" instead of "move foo bar" into the updates file, then by PMS's wording he can never again use "bar" as a package name, because it "has appeared as the origin of a move"?
Comment 3 Ciaran McCreesh 2009-12-13 15:58:38 UTC
So far as I'm aware, it's documented in the same place that most of Gentoo's other QA policies are documented, which is to say in single emails sent five years ago... That's part of what makes this such a nuisance.

The only removals from updates I can recall are when Seemant removed some of the older updates files several years after they were done, after very carefully checking that it was probably OK to do so. So far as I know no-one ever got around to documenting exactly what had to be done for that.

Other than that... There've been a couple of typos removed from there, which caused horrible problems for users... "Developers screwing up" isn't something tolerated by Portage in updates.

So yes, this pretty much has to be an absolute, at least the way things are now.
Comment 4 Ulrich Müller gentoo-dev 2009-12-13 16:49:03 UTC
Are your replies related to the last paragraph only, or to the full report?
Comment 5 Ciaran McCreesh 2009-12-13 16:52:14 UTC
As far as I can see all the "must not be reused" clause means all the issues in the report are equivalent, so my reply's about the entire thing.

Obviously, there's an exception if things get fixed before they hit rsync, and realistically we probably have to have an unwritten exception for things that get caught and fixed quickly, but so far as I know, anything that makes it out to lots of users has to be considered permanent and eternal.
Comment 6 Ciaran McCreesh 2009-12-13 17:07:13 UTC
What's the intent here? Are you trying to make it defined behaviour to rename a package to a name that has already been renamed to something else?
Comment 7 Ulrich Müller gentoo-dev 2009-12-13 17:13:30 UTC
See above: "slotmove <cat/foo-2 0 1" exists, but now upstream renamed from "foo" to "bar", so we need to "move cat/foo cat/bar" now. Zac tells me that this just works, without changing the prior slotmove.
Comment 8 Ciaran McCreesh 2009-12-13 17:32:06 UTC
The implications of this for overlays are fairly icky, if they don't apply the changes at exactly the same time. Do we care?
Comment 9 Ulrich Müller gentoo-dev 2009-12-13 17:48:13 UTC
(In reply to comment #8)
> The implications of this for overlays are fairly icky, if they don't apply the
> changes at exactly the same time.

The later change (the "move" in my example) must not be applied before the earlier one (the "slotmove") has been applied everywhere?

> Do we care?

Good question.
Comment 10 Ciaran McCreesh 2009-12-13 18:10:54 UTC
(In reply to comment #9)
> (In reply to comment #8)
> The later change (the "move" in my example) must not be applied before the
> earlier one (the "slotmove") has been applied everywhere?

Yeah.

Is there any way things can break if slotmoves are just re-applied later on for any moves?
Comment 11 Ulrich Müller gentoo-dev 2009-12-13 18:45:21 UTC
(In reply to comment #10)
> Is there any way things can break if slotmoves are just re-applied later on
> for any moves?

Like this?

   slotmove <cat/foo-2 0 1
   move cat/foo cat/bar
   slotmove <cat/bar-2 0 1

According to Zac, Portage applies it in order, so only the first two lines are necessary.
Comment 12 Ciaran McCreesh 2009-12-13 18:51:42 UTC
So in we have:

   slotmove <cat/foo-2 0 1
   move cat/foo cat/bar

and a user installs cat/bar-1:0, Portage does the slotmove on cat/bar even though the cat/bar in question has never been called cat/foo?
Comment 13 Ulrich Müller gentoo-dev 2009-12-14 05:38:27 UTC
(In reply to comment #12)
>    slotmove <cat/foo-2 0 1
>    move cat/foo cat/bar
> 
> and a user installs cat/bar-1:0, Portage does the slotmove on cat/bar even
> though the cat/bar in question has never been called cat/foo?

AFAIK, no. There is no slotmove for cat/bar. (Are we talking about the same thing here?)

Portage does the updates in the order that they occur in the file, therefore it cannot happen that an installed cat/foo-1:0 is first moved to cat/bar-1.0 and then misses the slotmove.
Comment 14 Ulrich Müller gentoo-dev 2019-08-23 16:17:03 UTC
Looking at this again, I think the spec is fine as it is. We could add a clarifying note like "In is unspecified in what order package moves are applied.", but I don't think this is strictly necessary. (If we don't specify it, then it is unspecified. :-)

As a consequence, the example in comment #11 would need all 3 lines, with no shortcuts allowed. Maybe it is better to require these moves to be explicit.